# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::ContentModerator::V1_0
  module Models
    #
    # The response for a Screen text request.
    #
    class Screen

      include MsRestAzure

      # @return [String] The original text.
      attr_accessor :original_text

      # @return [String] The normalized text.
      attr_accessor :normalized_text

      # @return [String] The autocorrected text
      attr_accessor :auto_corrected_text

      # @return [Array<String>] The misrepresentation text.
      attr_accessor :misrepresentation

      # @return [Classification] The classification details of the text.
      attr_accessor :classification

      # @return [Status] The evaluate status.
      attr_accessor :status

      # @return [PII] Personal Identifier Information details.
      attr_accessor :pii

      # @return [String] Language of the input text content.
      attr_accessor :language

      # @return [Array<DetectedTerms>]
      attr_accessor :terms

      # @return [String] Unique Content Moderator transaction Id.
      attr_accessor :tracking_id


      #
      # Mapper for Screen class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Screen',
          type: {
            name: 'Composite',
            class_name: 'Screen',
            model_properties: {
              original_text: {
                client_side_validation: true,
                required: false,
                serialized_name: 'OriginalText',
                type: {
                  name: 'String'
                }
              },
              normalized_text: {
                client_side_validation: true,
                required: false,
                serialized_name: 'NormalizedText',
                type: {
                  name: 'String'
                }
              },
              auto_corrected_text: {
                client_side_validation: true,
                required: false,
                serialized_name: 'AutoCorrectedText',
                type: {
                  name: 'String'
                }
              },
              misrepresentation: {
                client_side_validation: true,
                required: false,
                serialized_name: 'Misrepresentation',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              classification: {
                client_side_validation: true,
                required: false,
                serialized_name: 'Classification',
                type: {
                  name: 'Composite',
                  class_name: 'Classification'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'Status',
                type: {
                  name: 'Composite',
                  class_name: 'Status'
                }
              },
              pii: {
                client_side_validation: true,
                required: false,
                serialized_name: 'PII',
                type: {
                  name: 'Composite',
                  class_name: 'PII'
                }
              },
              language: {
                client_side_validation: true,
                required: false,
                serialized_name: 'Language',
                type: {
                  name: 'String'
                }
              },
              terms: {
                client_side_validation: true,
                required: false,
                serialized_name: 'Terms',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'DetectedTermsElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'DetectedTerms'
                      }
                  }
                }
              },
              tracking_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'TrackingId',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
